package com.FranckBarbier.Java._Introspection;

import com.FranckBarbier.Java._Temperature.Temperature;

public class Introspection {

    public static void main(String[] args) throws Exception {

        System.out.println("Absence of infinite instantiation graph regression in Java: " + Class.class.getName());

        Class<?> class_of_Temperature = Temperature.class;
        System.out.println("Class of 'class_of_Temperature': " + class_of_Temperature.getName());
        Class<?> class_of_Temperature_unit = Temperature.Temperature_unit.class;
        System.out.println("Class of 'class_of_Temperature_unit': " + class_of_Temperature_unit.getName());
        assert (class_of_Temperature == class_of_Temperature_unit.getEnclosingClass());
        Temperature ambient_temperature = new Temperature(18.F, Temperature.Temperature_unit.Celsius);
        assert (class_of_Temperature == ambient_temperature.getClass());
        for (Object object : class_of_Temperature_unit.getEnumConstants()) {
            System.out.println(object);
        }

        try {
            Temperature.Temperature_unit.class.getDeclaredConstructor().newInstance();
        } catch (InstantiationException ie) {
            System.err.println("Failure when dynamically creating a value of (enumerated type) "
                    + Temperature.Temperature_unit.class
                    + ": " + ie.getMessage());
        }

        java.lang.reflect.Method methods[] = ambient_temperature.getClass().getMethods();
        for (java.lang.reflect.Method method : methods) {
            Class<?>[] types_of_parameters = method.getParameterTypes();
            Object arguments[] = null;
            if (method.getName().equals("toString") && method.isVarArgs() == false && method.getParameterTypes().length == 0) {
                try {
                    System.out.println("Calling 'toString' by introspection on 'ambient_temperature': " + method.invoke(ambient_temperature, arguments));
                } catch (IllegalAccessException | IllegalArgumentException | java.lang.reflect.InvocationTargetException e) {
                    System.err.println(e.getMessage());
                }
            }
        }
    }
}
